import dnd, es, spe, popuplib, gamethread, playerlib
from dnd import dnd

def load():
    spe.registerPreHook("player_spawn", pre_spawn)
    spe.registerPreHook("player_hurt", pre_hurt)
    info = popuplib.create("Paladin Info")
    info.addline('Paladin Class Information:')
    info.addline('  Lay On Hands - When brought below 20% Health,')
    info.addline('    you are instantly healed. 1/round')
    info.addline('  Level 3: Divine Grace - Your armor gives Damage Reduction')
    info.addline('    and regenerates')
    info.addline(' Level 5: Divine Health - Increased Health')
    info.addline(' Level 9: Holy Sword - Your damage can not be reduced')
    info.addline('-> 9. Main Menu')
    info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Paladin Info')
    spe.unregisterPreHook("player_spawn", pre_spawn)
    spe.unregisterPreHook("player_hurt", pre_hurt)
    
def pre_spawn(ev):
    if dnd.Player(ev['userid']).getClass() == 'Paladin':
        dnd.Temp(ev['userid']).add('Fortitude', dnd.Player(ev['userid']).getLevel()/2+2)
        dnd.Temp(ev['userid']).add('Reflex', dnd.Player(ev['userid']).getLevel()/2+2)
        dnd.Temp(ev['userid']).add('Will', dnd.Player(ev['userid']).getLevel()/2+2)
        dnd.Temp(ev['userid']).add('Lay On Hands', 1)
        if dnd.Player(ev['userid']).getLevel() >= 5:
            dnd.Temp(ev['userid']).add('health', min(dnd.Player(ev['userid']).getLevel() * 5, 50))
        
def player_spawn(ev):
    armor_loop()
    if dnd.Player(ev['userid']).getClass() == 'Paladin':
            if dnd.Player(ev['userid']).getLevel() >= 3:
                dnd.armorregen(ev['userid'], 3, 5)
        
def pre_hurt(ev):
    if dnd.Player(ev['userid']).getClass() == "Paladin":
        if dnd.Player(ev['userid']).getLevel() >= 3:
            dnd.heal(ev['userid'], int(int(dnd.Temp(ev['userid']).get('damage reduction'))/100 * float(ev['dmg_health'])))
        if dnd.Temp(ev['userid']).get('Lay On Hands'):
            health = int(es.getplayerprop(ev['userid'], 'CBasePlayer.m_iHealth'))
            if health == 0:
                health = 1
            if int(dnd.Temp(ev['userid']).get('health')) / health >= 5:
                dnd.Temp(ev['userid']).add('Lay On Hands', -1)
                dnd.heal(ev['userid'], min(dnd.Player(ev['userid']).getLevel() * 10, 50))
                dnd.dndTell(ev['userid'], 'Your Lay On Hands has healed you for %s Health'%min(dnd.Player(ev['userid']).getLevel() * 10, 50))

def player_hurt(ev):
    if dnd.Player(ev['attacker']).getClass() == "Paladin":
        if dnd.Player(ev['attacker']).getLevel() >= 9:
            dnd.heal(ev['userid'], ev['dmg_health'])
            dnd.damage(ev['userid'], ev['attacker'], ev['dmg_health'],'Magic')
            
def armor_loop():
    for userid in es.getUseridList():
        if dnd.Player(userid).getClass() == 'Paladin':
            if dnd.Player(userid).getLevel() >= 3:
                dnd.Temp(userid).set('damage reduction', int(playerlib.getPlayer(userid).getArmor())/2)
    gamethread.delayedname(.1, 'dndtick', armor_loop)